/* ecah.h
 $Header: /al/acs/src/RCS/ecah.h,v 8.7 95/05/11 22:46:15 al Exp $
 * define assorted stuff
 */
#include "md.h"

/* misc. constants */
#define RANSCALE	(16384)
#define RANOFSET	(16384)
#define kPIx2		(6.2831853071795864769252867665590057683944)
#define kPI		(3.1415926535897932384626433832795028841972)
#define kPId2		(1.5707963267948966192313216916397514420986)
#define DTOR		(0.0174532925199432957692369076848861271344)
#define RTOD	       (57.2957795130823208768)
#define ONE_OVER_PI	(0.3183098861837906715377675267450287240689)
#define ABS_ZERO     (-273.15)
#define	E_0	(8.854214871e-12)  /* permittivity of air 		  */
#define	E_SI	(11.7*E_0)	   /* permittivity of silicon (1.0359e-10)*/
#define	E_OX	(3.9*E_0)	   /* permittivity of oxide (3.45e-11)	  */
#define K       (1.3806226e-23)    /* Boltzmann's constant		  */
#define Q       (1.6021918e-19)    /* electronic charge			  */
#define NOT_INPUT   (-(DBL_MAX)*(.8347658))	/* unlikely number	  */
#define NOT_VALID   (-(DBL_MAX)*(.8547958))	/* unlikely number	  */
#define LINEAR	    (-(DBL_MAX)*(.8747958))	/* unlikely number	  */
#define BIGBIG	    ( (DBL_MAX)*(.9747958))	/* unlikely number	  */
#define VOLTMIN	    (1.0e-50)
#define DBVOLTMIN   (20.*log10(VOLTMIN))
#define PWRMIN	    (1.0e-100)
#define DBPWRMIN    (10.*log10(PWRMIN))
#define TOKENTERM   ",=()[]"

#define	YES	(1)
#define	NO	(0)
#define	MAYBE	(-YES)
#define	BAD	(-1)
#define	GOOD	(0)

#ifdef MAX
#undef MAX
#endif
#ifdef MIN
#undef MIN
#endif

inline double MAX(double x, double y)
   {return (x>y) ? x : y;}
inline int MAX(int x, int y)
   {return (x>y) ? x : y;}

inline double MIN(double x, double y)
   {return (x<y) ? x : y;}

inline int uporder(double a, double b, double c)
   {return (a<=b) && (b<=c);}

inline int inorder(double a, double b, double c)
   {return uporder(a,b,c) || uporder(c,b,a);}

inline double torange(double a, double b, double c)
   {return MIN(MAX(a,b),c);}

struct fpoly1_t{	/* first order polynomial	*/
   double  x;		/* the argument			*/
   double  f0;		/* the function (c0 + x*f1)	*/
   double  f1;		/* the first derivative		*/
   fpoly1_t()		{x=0.;	f0=0.;	f1=0;	}
   fpoly1_t(fpoly1_t& p){x=p.x;	f0=p.f0;f1=p.f1;}
};

struct cpoly1_t{	/* first order polynomial	*/
   double  x;		/* the argument			*/
   double  c0;		/* f(x) - x*f'(x), or f0 - x*f1 */
   double  f1;		/* the first derivative		*/
   cpoly1_t()		{x=0.;	c0=0.;	f1=0;	}
   cpoly1_t(cpoly1_t& p){x=p.x;	c0=p.c0;f1=p.f1;}
};
